#if PLATFORM_IOS
#import "AppGuardSDKPrivatePCH.h"
#import "AppGuardUE4Manager.h"

#import <AppGuardCore/AppGuard.h>
#import <AppGuardCore/AppGuardDefine.h>
#import <UIKit/UIKit.h>
static void APPGUARDCALLBACK(int type, int code, const char* desc)
{
    if( type == APPGUARD_TYPE_S2AUTH_CALLBACK) {
        FString dataString = UTF8_TO_TCHAR(desc);
        FAppGuardSDKModule::OnS2AuthCompleted.Broadcast(code, dataString);
    } else if( type == APPGUARD_TYPE_KILL) {
        FAppGuardSDKModule::OnDetected.Broadcast(code);
    } else if( type == APPGUARD_TYPE_DETECT) {
        FAppGuardSDKModule::OnDetected.Broadcast(code * -1);
    }
}
void AppGuardInit()
{
    APPGUARD_INIT(APPGUARDCALLBACK);
}
const char* AppGuardGetUDID()
{
    const char* udid = APPGUARD_GET_UDID;
    return udid;
}
void AppGuardSetUserID(const char* userid)
{
    APPGUARD_SET_USER_ID(userid);
}
void AppGuardSetCertificationID(const char* uniqueid, long retryTimeSec)
{
    if(retryTimeSec <= 0) {
        retryTimeSec = 180;
    }
    APPGUARD_SET_CERTIFICATION_ID(uniqueid, retryTimeSec);
}
#endif // PLATFORM_IOS
