// Copyright Epic Games, Inc. All Rights Reserved.

#pragma once

#include "CoreUObject.h"
#include "Engine.h"
#include "Modules/ModuleManager.h"

namespace AppGuardEventType {
    class S2Auth {
        public:
            static const int S2AUTH_RESULT_SUCCESS  = 1;
            static const int S2AUTH_RESULT_RETRY    = 2;
            static const int S2AUTH_RESULT_FAIL     = 3;
    };

    class Detect {
        public:
        	static const int DETECT_INVALID_APK_SIGN 			 = 3;
            static const int DETECT_RUNNGING_BAD_APPLICATION = 21;
            /*
             ...
             Please refer to the AppGuard API documentation.
            */
    };
}

class APPGUARDSDK_API FAppGuardSDKModule : public IModuleInterface
{
public:
	static inline FAppGuardSDKModule& Get()
    {
        return FModuleManager::LoadModuleChecked< FAppGuardSDKModule >( "AppGuardSDK" );
    }

	static inline bool IsAvailable()
    {
        return FModuleManager::Get().IsModuleLoaded( "AppGuardSDK" );
    }

	DECLARE_MULTICAST_DELEGATE_TwoParams(FOnS2AuthCompleted, int, const FString &);
	DECLARE_MULTICAST_DELEGATE_OneParam(FOnDetected, int);

	static FOnS2AuthCompleted OnS2AuthCompleted;
	static FOnDetected OnDetected;
};
